/*
(c) Copyright Taiichi Yuasa and Masami Hagiya, 1984.  All rights reserved.
Copying of this file is authorized to users who have executed the true and
proper "License Agreement for Kyoto Common LISP" with SIGLISP.
*/

/*
	include.h
*/


/*

BYTE_ADDRESS -- byte addressing
IEEEFLOAT -- IEEE floating point format
CORE_STARTS_NEAR_0 --- Core starts near the address 0.
DOWN_STACK -- downward stack
ARGS_ON_STACK -- Parameters are passed via the stack.
BSTATIC_REQUIRED -- Bstatic option required for the linker
REVERSE_PARAMETER_ORDER -- Parameter order is reversed.
SIGNED_CHAR -- signed char
CC_OPTIMIZES_TEST -- C compiler optimizes arithmetic test.
REGISTER_VAR -- C compiler supports register variables.

UNIX -- UNIX operating system
BSD -- UNIX BSD
ATT -- UNIX System ?
ALLOCATE_INCREMENTALLY -- Core is allocated incrementally.
ALLOW_FORK -- Fork is allowed.

BITOP_C -- Use the C definitions in bitop.c, instead of assembler defs.
EARITH_C -- Use the C definitions in earith.c, instead of assembler defs.
WORD_SWAPPED -- IEEE float format with the first word (ie the word with
		exponent) in higher address.  32-bit object with the higher
		half in the higher address.  Typical for 80386.

IMMED -- Allow immediate data for fixnums, characters, and shortfloats.
*/




#ifdef VAX
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef SUN
#define	MC68K
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef SUN2R3
#define	MC68K
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef SUN3
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#define	IMMED
#endif

#ifdef SUN3OS4
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#define	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#define	IMMED
#endif

#ifdef SUN4
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#undef	ARGS_ON_STACK
#define	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#define	BITOP_C
#define EARITH_C
#define	IMMED
#endif

#ifdef LUNA
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#define	BITOP_C
#define EARITH_C
#undef	IMMED
#endif

#ifdef NEWS
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

/* ISI */

#ifdef SEQ
#define	NS32K
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

/* IBMRT */

#ifdef ATT3B2
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#undef	CORE_STARTS_NEAR_0
#define	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#define	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	ATT
#undef	ALLOCATE_INCREMENTALLY
#undef	ALLOW_FORK
#undef	IMMED
#endif

#ifdef S3000
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	ATT
#undef	ALLOCATE_INCREMENTALLY
#undef	ALLOW_FORK
#undef	IMMED
#endif

#ifdef OMRON
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#define	ATT
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef E15
#define	MC68K
#define	IEEEFLOAT
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define	UNIX
#undef	ALLOCATE_INCREMENTALLY
#undef	ALLOW_FORK
#undef	IMMED
#endif

#ifdef DGUX
#define	MV
#undef	BYTE_ADDRESS
#undef	CORE_STARTS_NEAR_0
#define	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#define	REVERSE_PARAMETER_ORDER
#undef	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#undef	REGISTER_VAR
#define	UNIX
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef AOSVS
#define	MV
#undef	BYTE_ADDRESS
#undef	CORE_STARTS_NEAR_0
#define	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#define	REVERSE_PARAMETER_ORDER
#undef	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#undef	REGISTER_VAR
#undef	IMMED
#endif

#ifdef TAHOE
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#define	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define UNIX
#define BSD
#define	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#undef	IMMED
#endif

#ifdef BE
#define	IEEEFLOAT
#define	WORD_SWAPPED
#define	BYTE_ADDRESS
#define	CORE_STARTS_NEAR_0
#undef	DOWN_STACK
#define ARGS_ON_STACK
#undef	BSTATIC_REQUIRED
#undef	REVERSE_PARAMETER_ORDER
#define	SIGNED_CHAR
#undef	CC_OPTIMIZES_TEST
#define	REGISTER_VAR
#define UNIX
#define ATT
#undef	ALLOCATE_INCREMENTALLY
#define	ALLOW_FORK
#define BITOP_C
#define EARITH_C
#define	IMMED
#endif

#ifdef S3000
#define BITOP_C
#undef	IMMED
#endif

#ifdef NS32K
#define WORD_SWAPPED
#endif



#include <stdio.h>
#include <setjmp.h>

#ifdef UNIX
#include <ctype.h>
#define	isalphanum(x)	isalnum(x)
#endif


#include "../h/object.h"
#include "../h/vs.h"
#include "../h/symbol.h"
#include "../h/bds.h"
#include "../h/frame.h"
#include "../h/lex.h"
#include "../h/eval.h"

#ifdef ATT3B2
#include "../h/att_ext.h"
#else
#include "../h/external.h"
#endif

#include "../h/rgbc.h"
