/*
	(C) Copyright Taiichi Yuasa and Masami Hagiya, 1984
*/

#include "stdio.h"
#include "sysid.h"
#include "paru.h"
#include "packets:filestatus"

struct ob_header {
	short	type;
	short	numer;
	short	len;
	};

#define HEADER_LEN 6
#define END_BLOCK 2

char	fasl_buf[BUFSIZ];
char	ob_buf[BUFSIZ];
char	copy_buf[BUFSIZ];

main(argc, argv)
int argc;
char *argv[];
{

	FILE	*fasl, *ob;
	char	filename[512];
	char	faslname[512], obname[512];
	int	i, ier;
	int	len;
	short	ob_type, ob_len;
	char	len_str[11];

	if (argc < 3) errexit(ERNNL);

	get_path(argv[1], faslname, 512);
	get_path(argv[2], obname, 512);

	len = file_len(faslname);

	if ((fasl = fopen(faslname, "r+")) == NULL)
		errexit(lasterror());
	setbuf(fasl, fasl_buf);

	if (fprintf(fasl, "%10d", len) == -1)
		errexit(lasterror());
	if (fseek(fasl, 0, 2) == -1)
		errexit(lasterror());

	if ((ob = fopen(obname, "r")) == NULL)
		errexit(lasterror());
	setbuf(ob, ob_buf);

	/* copy ???.OB to ???.FASL */

	do {
		if (fread(copy_buf, HEADER_LEN, 1, ob) != 1)
			errexit(lasterror());
		ob_type = (struct ob_header *)copy_buf->type;
		ob_len = (struct ob_header *)copy_buf->len;
		ob_len = ob_len * 2 - HEADER_LEN;
		if (fwrite(copy_buf, HEADER_LEN, 1, fasl) != 1)
			errexit(ier);
		if (fread(copy_buf, ob_len, 1, ob) != 1)
			errexit(lasterror());
		if (fwrite(copy_buf, ob_len, 1, fasl) != 1)
			errexit(lasterror());
	} while(ob_type != END_BLOCK);
	fclose(fasl);
	fclose(ob);
}

int
file_len(filen)
char *filen;
{
	int ac0, ac1, ac2, ier;
	P_FSTAT filep;

	ac0 = filen;
	ac1 = 0;
	ac2 = &filep;
	if (ier = sys($FSTAT, &ac0, &ac1, &ac2))
		errexit(ier);
	return(filep.sefm);
}

get_path(filen, truename, bufflen)
char *filen, *truename;
int bufflen;
{
	int ac0, ac1, ac2, ier;

	ac0 = filen;
	ac1 = truename;
	ac2 = bufflen;
	if (ier = sys($GNAME, &ac0, &ac1, &ac2))
		errexit(ier);
}

errexit(ier)
int	ier;
{
	int ac0, ac1, ac2;

	ac0 = ier;
	ac2 = $RFEC | $RFCF | $RFER;
	sys($RETURN, &ac0, &ac1, &ac2);
	exit(ier);
}
